Lattice Grid Buy a licence

demo D218

The form, four ways

The same row form as a drawer, a dialog, an inline region and a curated set

rowForm: { mode: 'drawer' · 'dialog', container }

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">
<style>
  #buttons { display: flex; gap: 8px; margin-bottom: 12px; }
  #panes { display: flex; gap: 14px; }
  #grid { flex: 1; }
  #grid > div { height: 520px; }
  #inline-form { width: 320px; }
</style>
<div id="app"></div>

<script type="module">
  import * as Vue from 'https://esm.sh/vue@3';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/vue.esm.min.js';

  const LatticeGrid = createLatticeGrid({ vue: Vue, createGrid });

  Vue.createApp({
    components: { LatticeGrid },
    data() {
      const fields = [
        { field: 'service', label: 'Service' },
        { field: 'team', label: 'Team' },
        { field: 'region', label: 'Region' },
        { field: 'tier', label: 'Tier' },
        { field: 'instances', label: 'Instances' },
        { field: 'monthlyCost', label: 'Monthly cost' },
        { field: 'notes', label: 'Notes', editor: 'textarea' },
      ];
      return {
        mode: 'drawer',
        // The same form, placed four ways. Only the rowForm option differs:
        //   drawer - a right-hand panel (the default)
        //   dialog - a centred modal
        //   inline - built into an element of your own; a region, not a modal
        //   curated - the drawer with a chosen few fields
        modes: {
          drawer:  { mode: 'drawer', title: 'Edit service', fields },
          dialog:  { mode: 'dialog', title: 'Edit service', fields },
          inline:  { fields, container: '#inline-form' },
          curated: { mode: 'drawer', title: 'Quick edit',
            fields: [{ field: 'tier', label: 'Tier' }, { field: 'instances', label: 'Instances' },
                     { field: 'notes', label: 'Notes', editor: 'textarea' }] },
        },
        columns: [
          { field: 'service', title: 'Service', layout: { pin: 'start', width: 150 } },
          { field: 'team', title: 'Team', filter: { type: 'set' } },
          { field: 'region', title: 'Region', filter: { type: 'set' } },
          { field: 'tier', title: 'Tier' },
          { field: 'instances', title: 'Instances', type: 'number' },
          { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
        ],
      };
    },
    computed: {
      // rowForm is read when the grid is built, so keying the component on the mode
      // rebuilds it whenever the placement changes.
      config() {
        return { rowKey: 'id', editable: true, rowForm: this.modes[this.mode], columns: this.columns, rows };
      },
    },
    watch: {
      mode() {
        // Open it on the rebuilt grid so the placement shows.
        this.$nextTick(() => this.$refs.grid.grid().form.open(String(rows[0].id)));
      },
    },
    mounted() {
      this.$refs.grid.grid().form.open(String(rows[0].id));
    },
    template: `
      <div>
        <div id="buttons">
          <button v-for="name in Object.keys(modes)" :key="name" @click="mode = name">{{ name }}</button>
        </div>
        <div id="panes">
          <div id="grid"><lattice-grid :key="mode" ref="grid" v-bind="config" /></div>
          <div id="inline-form"></div>
        </div>
      </div>
    `,
  }).mount('#app');
</script>

Lattice Grid Buy a licence

demo D218

The form, four ways

The same row form as a drawer, a dialog, an inline region and a curated set

rowForm: { mode: 'drawer' · 'dialog', container }

Building…
Loading a live grid…

The configuration

<script>
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeAction from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/svelte.esm.min.js';

  const lattice = createLatticeAction({ createGrid });

  const fields = [
    { field: 'service', label: 'Service' },
    { field: 'team', label: 'Team' },
    { field: 'region', label: 'Region' },
    { field: 'tier', label: 'Tier' },
    { field: 'instances', label: 'Instances' },
    { field: 'monthlyCost', label: 'Monthly cost' },
    { field: 'notes', label: 'Notes', editor: 'textarea' },
  ];

  // The same form, placed four ways. Only the rowForm option differs:
  //   drawer - a right-hand panel (the default)
  //   dialog - a centred modal
  //   inline - built into an element of your own; a region, not a modal
  //   curated - the drawer with a chosen few fields
  const modes = {
    drawer:  { mode: 'drawer', title: 'Edit service', fields },
    dialog:  { mode: 'dialog', title: 'Edit service', fields },
    inline:  { fields, container: '#inline-form' },
    curated: { mode: 'drawer', title: 'Quick edit',
      fields: [{ field: 'tier', label: 'Tier' }, { field: 'instances', label: 'Instances' },
               { field: 'notes', label: 'Notes', editor: 'textarea' }] },
  };

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 150 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'tier', title: 'Tier' },
    { field: 'instances', title: 'Instances', type: 'number' },
    { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
  ];

  // Switching mode re-keys the block below, so the action tears the grid down and
  // rebuilds it with the chosen placement. onGrid opens the form on the first row
  // so the placement shows.
  let mode = 'drawer';
  $: config = {
    rowKey: 'id', editable: true, rowForm: modes[mode], columns, rows,
    onGrid: (grid) => { grid.form.open(String(rows[0].id)); },
  };
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">
</svelte:head>

<div style="display: flex; gap: 8px; margin-bottom: 12px">
  {#each Object.keys(modes) as name}
    <button on:click={() => (mode = name)}>{name}</button>
  {/each}
</div>
<div style="display: flex; gap: 14px">
  {#key mode}
    <div use:lattice={config} style="flex: 1; height: 520px"></div>
  {/key}
  <div id="inline-form" style="width: 320px"></div>
</div>

Lattice Grid Buy a licence

demo D218

The form, four ways

The same row form as a drawer, a dialog, an inline region and a curated set

rowForm: { mode: 'drawer' · 'dialog', container }

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const fields = [
    { field: 'service', label: 'Service' },
    { field: 'team', label: 'Team' },
    { field: 'region', label: 'Region' },
    { field: 'tier', label: 'Tier' },
    { field: 'instances', label: 'Instances' },
    { field: 'monthlyCost', label: 'Monthly cost' },
    { field: 'notes', label: 'Notes', editor: 'textarea' },
  ];

  // The same form, placed four ways. Only the rowForm option differs:
  //   drawer  - a right-hand panel (the default)
  //   dialog  - a centred modal
  //   inline  - built into an element of your own; a region, not a modal
  //   curated - the drawer with a chosen few fields
  const modes = {
    drawer:  { mode: 'drawer', title: 'Edit service', fields },
    dialog:  { mode: 'dialog', title: 'Edit service', fields },
    inline:  { fields, container: '#inline-form' },
    curated: { mode: 'drawer', title: 'Quick edit',
      fields: [{ field: 'tier', label: 'Tier' }, { field: 'instances', label: 'Instances' },
               { field: 'notes', label: 'Notes', editor: 'textarea' }] },
  };

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 150 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'tier', title: 'Tier' },
    { field: 'instances', title: 'Instances', type: 'number' },
    { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
  ];

  const rows = [/* service records */];

  function App() {
    const gridRef = React.useRef(null);
    const [mode, setMode] = React.useState('drawer');

    // Open the first row after each switch, so the placement shows. The rowForm
    // prop carries the whole configuration, so changing it reconfigures in place.
    React.useEffect(() => {
      const grid = gridRef.current && gridRef.current.grid;
      if (grid) grid.form.open(String(rows[0].id));
    }, [mode]);

    return (
      <>
        <div style={{ display: 'flex', gap: '8px', marginBottom: '12px' }}>
          {Object.keys(modes).map((name) => (
            <button key={name} onClick={() => setMode(name)} aria-pressed={name === mode}>{name}</button>
          ))}
        </div>
        <div style={{ display: 'flex', gap: '14px' }}>
          <LatticeGrid
            ref={gridRef}
            rowKey="id"
            editable
            rowForm={modes[mode]}
            columns={columns}
            rows={rows}
            style={{ flex: 1, height: '520px' }}
          />
          <div id="inline-form" style={{ width: '320px' }} />
        </div>
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D218

The form, four ways

The same row form as a drawer, a dialog, an inline region and a curated set

rowForm: { mode: 'drawer' · 'dialog', container }

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { CommonModule } from '@angular/common';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const fields = [
  { field: 'service', label: 'Service' },
  { field: 'team', label: 'Team' },
  { field: 'region', label: 'Region' },
  { field: 'tier', label: 'Tier' },
  { field: 'instances', label: 'Instances' },
  { field: 'monthlyCost', label: 'Monthly cost' },
  { field: 'notes', label: 'Notes', editor: 'textarea' },
];

// The same form, placed four ways. Only the rowForm option differs:
//   drawer  - a right-hand panel (the default)
//   dialog  - a centred modal
//   inline  - built into an element of your own; a region, not a modal
//   curated - the drawer with a chosen few fields
const modes: any = {
  drawer:  { mode: 'drawer', title: 'Edit service', fields },
  dialog:  { mode: 'dialog', title: 'Edit service', fields },
  inline:  { fields, container: '#inline-form' },
  curated: { mode: 'drawer', title: 'Quick edit',
    fields: [{ field: 'tier', label: 'Tier' }, { field: 'instances', label: 'Instances' },
             { field: 'notes', label: 'Notes', editor: 'textarea' }] },
};

const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 150 } },
  { field: 'team', title: 'Team', filter: { type: 'set' } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'tier', title: 'Tier' },
  { field: 'instances', title: 'Instances', type: 'number' },
  { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
];

const rows: any[] = [/* service records */];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, LatticeGridComponent],
  template:
    '<div style="display:flex;gap:8px;margin-bottom:12px">' +
    '  <button *ngFor="let name of modeNames" (click)="setMode(name)" [attr.aria-pressed]="name === mode">{{ name }}</button>' +
    '</div>' +
    '<div style="display:flex;gap:14px">' +
    '  <lattice-grid [config]="grid" style="flex:1;height:520px"></lattice-grid>' +
    '  <div id="inline-form" style="width:320px"></div>' +
    '</div>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;
  modeNames = Object.keys(modes);
  mode = 'drawer';

  grid: any = { rowKey: 'id', editable: true, rowForm: modes['drawer'], columns, rows };

  // The rowForm option carries the whole configuration, so changing it
  // reconfigures in place. Open the first row after each switch, so the
  // placement shows.
  setMode(name: string) {
    this.mode = name;
    this.grid = { ...this.grid, rowForm: modes[name] };
    queueMicrotask(() => this.gridRef.grid?.form.open(String(rows[0].id)));
  }

  ngAfterViewInit() { this.gridRef.grid?.form.open(String(rows[0].id)); }
}

bootstrapApplication(AppComponent);